import es, gamethread, playerlib, popuplib, random, time, votelib
from time import strftime

admins = ['STEAM_0:0:xxxxxxxxx', 'STEAM_0:0:xxxxxxxxx']			##  SteamID of admins

def load():
	es.addons.registerSayFilter(adminplugin_SayFilter)			## Usable chat commands for players: adminlist, votekick, voteban, votemap, timeleft, thetime
													## Usable chat messages for admins: 
													##    say: @message - common message to all players, as admin
													##    say_team: @message - private message to all the other admins, not visible for players
													##    say: #message - center message to all players, as admin
													##    say: $message - toptext message to all players, as admin
	es.regclientcmd('admin_menu', 'adminplugin/check_admin')		## Command in console or bind to a key to display admin menu
	es.set('sv_adverts_enable', '1', 'Enables or disables adverts display')
	es.set('sv_adverts_time', '30', 'Intervall in seconds to display adverts')
	es.set('sv_voteban_enable', '1', 'Enables or disables ban voting')
	es.set('sv_voteban_time', '60', 'Ban time in minutes of the player that has been ban voted')
	es.set('sv_votekick_enable', '1', 'Enables or disables kick voting')
	es.set('sv_votemap_enable', '1', 'Enables or disables map voting')
	show_adverts()

def es_map_start(event_var):
	global time_left_starttime
	time_left_starttime = int(time.time())
	es.server.cmd('exec admin_plugin.cfg')

def check_admin():
	userid = es.getcmduserid()
	if es.getplayersteamid(userid) not in admins:
		es.tell(userid, '#multi', '#defaultYou are not #lightgreenAdmin#default. You cannot use this command')
		return
	admin_main(userid)

def admin_main(userid):
	adminmain = popuplib.create('adminmain')
	adminmain.addline('Admin Main Menu')
	adminmain.addline('-------------------------')
	adminmain.addline('->1. Player management')
	adminmain.addline('->2. Map management')
	adminmain.addline('->3. Server commands')
	adminmain.addline('->4. Custom votes')
	adminmain.addline(' ')
	adminmain.addline('0. Cancel')
	adminmain.timeoutview = 12
	adminmain.menuselect = adminmain_menu
	if popuplib.isqueued('adminmain', userid): popuplib.close('adminmain', userid)
	popuplib.send('adminmain', userid)

def admin_player(userid):
	adminplayer = popuplib.create('adminplayer')
	adminplayer.addline('Admin Player Menu')
	adminplayer.addline('-------------------------')
	adminplayer.addline('->1. Kick player')
	adminplayer.addline('->2. Ban player')
	adminplayer.addline('->3. Slay player')
	adminplayer.addline('->4. Change name')
	adminplayer.addline('->5. Change team')
	adminplayer.addline('->6. Teleport')
	adminplayer.addline(' ')
	adminplayer.addline('->9. Back to main menu')
	adminplayer.addline('0. Cancel')
	adminplayer.timeoutview = 12
	adminplayer.menuselect = adminplayer_menu
	popuplib.send('adminplayer', userid)

def admin_map(userid):
	adminmap = popuplib.create('adminmap')
	adminmap.addline('Admin Map Menu')
	adminmap.addline('-------------------------')
	adminmap.addline('->1. Change the map now')
	adminmap.addline('->2. Change after round end')
	adminmap.addline('->3. Set the next map')
	adminmap.addline('->4. Specific map vote')
	adminmap.addline('->5. All maps vote')
	adminmap.addline(' ')
	adminmap.addline('->9. Back to main menu')
	adminmap.addline('0. Cancel')
	adminmap.timeoutview = 12
	adminmap.menuselect = adminmap_menu
	popuplib.send('adminmap', userid)

def admin_server(userid):
	adminserver = popuplib.create('adminserver')
	adminserver.addline('Server Commands')
	adminserver.addline('-------------------------')
	adminserver.addline('->1. Restart server')
	adminserver.addline('->2. Shutdown server')
	adminserver.addline('->3. Server variables')
	adminserver.addline('->3. Weapon Arena')
	adminserver.addline(' ')
	adminserver.addline('->9. Back to main menu')
	adminserver.addline('0. Cancel')
	adminserver.timeoutview = 12
	adminserver.menuselect = adminserver_menu
	popuplib.send('adminserver', userid)

def admin_custom(userid):
	admincustom = popuplib.create('admincustom')
	admincustom.addline('Custom Votes')
	admincustom.addline('-------------------------')
	admincustom.addline('->1. Player kick')
	admincustom.addline('->2. Player ban')
	admincustom.addline(' ')
	admincustom.addline('->9. Back to main menu')
	admincustom.addline('0. Cancel')
	admincustom.timeoutview = 12
	admincustom.menuselect = admincustom_menu
	popuplib.send('admincustom', userid)

def teamchange(userid):
	teamchange = popuplib.create('teamchange')
	teamchange.addline('Team Change Menu')
	teamchange.addline('-------------------------')
	teamchange.addline('->1. Spectator')
	teamchange.addline('->2. Terrorist')
	teamchange.addline('->3. Counter-Terrorist')
	teamchange.addline(' ')
	teamchange.addline('->8. Back to player menu')
	teamchange.addline('->9. Back to main menu')
	teamchange.addline('0. Cancel')
	teamchange.timeoutview = 12
	teamchange.menuselect = teamchange_menu
	popuplib.send('teamchange', userid)

def banplayer(userid):
	banplayer = popuplib.create('banplayer')
	banplayer.addline('Player Ban Menu')
	banplayer.addline('-------------------------')
	banplayer.addline('->1. Ban by SteamID')
	banplayer.addline('->2. Ban by IP')
	banplayer.addline('->3. Use both methods')
	banplayer.addline(' ')
	banplayer.addline('->8. Back to player menu')
	banplayer.addline('->9. Back to main menu')
	banplayer.addline('0. Cancel')
	banplayer.timeoutview = 12
	banplayer.menuselect = banplayer_menu
	popuplib.send('banplayer', userid)

def teleport(userid):
	teleport = popuplib.create('teleport')
	teleport.addline('Teleport Menu')
	teleport.addline('------------------------------')
	teleport.addline('->1. Teleport me to player')
	teleport.addline('->2. Teleport player to me')
	teleport.addline(' ')
	teleport.addline('->8. Back to player menu')
	teleport.addline('->9. Back to main menu')
	teleport.addline('0. Cancel')
	teleport.timeoutview = 12
	teleport.menuselect = teleport_menu
	popuplib.send('teleport', userid)

def adminmain_menu(userid, choice, popupid):
	if choice == 1: admin_player(userid)
	elif choice == 2: admin_map(userid)
	elif choice == 3: admin_server(userid)
	elif choice == 4: admin_custom(userid)
	popuplib.delete('adminmain')

def adminplayer_menu(userid, choice, popupid):
	if choice == 1:
		kick_player = popuplib.construct('kick_player', 'players', '#human', kick_player_select)
		kick_player.settitle("Select a Player:")
		kick_player.timeoutview = 12
		popuplib.send('kick_player', userid)
	elif choice == 2: banplayer(userid)
	elif choice == 3:
		slay_player = popuplib.construct('slay_player', 'players', '#alive', slay_player_select)
		slay_player.settitle("Select a Player:")
		slay_player.timeoutview = 12
		popuplib.send('slay_player', userid)
	elif choice == 4:
		namechange_player = popuplib.construct('namechange_player', 'players', '#human', namechange_player_select)
		namechange_player.settitle("Select a Player:")
		namechange_player.timeoutview = 12
		popuplib.send('namechange_player', userid)
	elif choice == 5: teamchange(userid)
	elif choice == 6: teleport(userid)
	elif choice == 9: admin_main(userid)
	popuplib.delete('adminplayer')

def adminmap_menu(userid, choice, popupid):
	if choice == 1: changemap_now(userid)
	elif choice == 2: changemap_end(userid)
	elif choice == 3: set_nextmap(userid)
	elif choice == 4: vote_one_map(userid)
	elif choice == 5: vote_all_map(userid)
	elif choice == 9: admin_main(userid)
	popuplib.delete('adminmap')

def adminserver_menu(userid, choice, popupid):
	if choice == 1: server_restart()
	elif choice == 2: server_shutdown()
	elif choice == 3: es.tell(userid, '#multi', '#defaultWasaaaaaaaaaaaaaaaaaaaaaa!!!')
	elif choice == 4: es.tell(userid, '#multi', '#defaultWasaaaaaaaaaaaaaaaaaaaaaa!!!')
	elif choice == 9: admin_main(userid)
	popuplib.delete('adminserver')

def admincustom_menu(userid, choice, popupid):
	if choice == 1:
		vote_kick = popuplib.construct('vote_kick', 'players', '#human', vote_kick_select)
		vote_kick.settitle("Select a Player:")
		vote_kick.timeoutview = 12
		popuplib.send('vote_kick', userid)
	elif choice == 2: 
		vote_ban = popuplib.construct('vote_ban', 'players', '#human', vote_ban_select)
		vote_ban.settitle("Select a Player:")
		vote_ban.timeoutview = 12
		popuplib.send('vote_ban', userid)
	elif choice == 9: admin_main(userid)
	popuplib.delete('admincustom')

def banplayer_menu(userid, choice, popupid):
	if choice == 1:
		steamban_player = popuplib.construct('steamban_player', 'players', '#human', steamban_player_select)
		steamban_player.settitle("Select a Player:")
		steamban_player.timeoutview = 12
		popuplib.send('steamban_player', userid)
	elif choice == 2:
		ipban_player = popuplib.construct('ipban_player', 'players', '#human', ipban_player_select)
		ipban_player.settitle("Select a Player:")
		ipban_player.timeoutview = 12
		popuplib.send('ipban_player', userid)
	elif choice == 3:
		bothban_player = popuplib.construct('bothban_player', 'players', '#human', bothban_player_select)
		bothban_player.settitle("Select a Player:")
		bothban_player.timeoutview = 12
		popuplib.send('bothban_player', userid)
	elif choice == 8: admin_player(userid)
	elif choice == 9: admin_main(userid)
	popuplib.delete('banplayer')

def teamchange_menu(userid, choice, popupid):
	if choice == 1:
		spec_player = popuplib.construct('spec_player', 'players', '#all', spec_player_select)
		spec_player.settitle("Select a Player:")
		spec_player.timeoutview = 12
		popuplib.send('spec_player', userid)
	elif choice == 2:
		terr_player = popuplib.construct('terr_player', 'players', '#ct', terr_player_select)
		terr_player.settitle("Select a Player:")
		terr_player.timeoutview = 12
		popuplib.send('terr_player', userid)
	elif choice == 3:
		cter_player = popuplib.construct('cter_player', 'players', '#t', cter_player_select)
		cter_player.settitle("Select a Player:")
		cter_player.timeoutview = 12
		popuplib.send('cter_player', userid)
	elif choice == 8: admin_player(userid)
	elif choice == 9: admin_main(userid)
	popuplib.delete('teamchange')

def kick_player_select(userid, choice, popupid):
	kicked = int(choice)
	es.msg('#multi', '#lightgreen%s#default has been kicked by Admin' % es.getplayername(kicked))
	es.server.queuecmd('kickid %s "Kicked by Admin"' % kicked)
	popuplib.delete('kick_player')

def steamban_player_select(userid, choice, popupid):
	banned = int(choice)
	es.msg('#multi', '#defaultPlayer lightgreen%s#default added to banned list' % es.getplayername(banned))
	es.server.queuecmd('banid 0 %s;writeid' % banned)
	es.server.queuecmd('kickid %s "Added to banned list"' % banned)
	popuplib.delete('steamban_player')

def ipban_player_select(userid, choice, popupid):
	banned = int(choice)
	playerip = playerlib.getPlayer(banned).get('address')[:-6]
	es.msg('#multi', '#defaultIP #lightgreen%s#default added to banned list' % playerip)
	es.server.queuecmd('addip 0 %s;writeip' % playerip)
	popuplib.delete('ipban_player')

def bothban_player_select(userid, choice, popupid):
	banned = int(choice)
	playerip = playerlib.getPlayer(banned).get('address')[:-6]
	es.msg('#multi', '#defaultPlayer lightgreen%s#default added to banned list' % es.getplayername(banned))
	es.msg('#multi', '#defaultIP #lightgreen%s#default added to banned list' % playerip)
	es.server.queuecmd('banid 0 %s;writeid' % banned)
	es.server.queuecmd('addip 0 %s;writeip' % playerip)
	popuplib.delete('bothban_player')

def slay_player_select(userid, choice, popupid):
	slayed = int(choice)
	es.msg('#multi', '#lightgreen%s#default has been slayed by Admin' % es.getplayername(slayed))
	es.sexec(slayed, 'kill')
	popuplib.delete('slay_player')

def namechange_player_select(userid, choice, popupid):
	namechanged = int(choice)
	es.msg('#multi', '#defaultAdmin forced #lightgreen%s#default to change his name' % es.getplayername(namechanged))
	es.cexec(namechanged, 'name ChangeName')
	popuplib.delete('namechange_player')

def spec_player_select(userid, choice, popupid):
	teamchanged = int(choice)
	es.msg('#multi', '#defaultAdmin moved #lightgreen%s#default to #darkgreenSpectators' % es.getplayername(teamchanged))
	es.changeteam(teamchanged, 1)
	popuplib.delete('spec_player')

def terr_player_select(userid, choice, popupid):
	teamchanged = int(choice)
	es.msg('#multi', '#defaultAdmin moved #lightgreen%s#default to #darkgreenTerrorists' % es.getplayername(teamchanged))
	es.changeteam(teamchanged, 2)
	popuplib.delete('terr_player')

def cter_player_select(userid, choice, popupid):
	teamchanged = int(choice)
	es.msg('#multi', '#defaultAdmin moved #lightgreen%s#default to #darkgreenCounter-Terrorists' % es.getplayername(teamchanged))
	es.changeteam(teamchanged, 3)
	popuplib.delete('cter_player')

def teleport_menu(userid, choice, popupid):
	if choice == 1:
		teleport_list = popuplib.construct('teleport_list', 'players', '#alive', teleport_list_select)
		teleport_list.settitle("Select a Player:")
		teleport_list.timeoutview = 12
		popuplib.send('teleport_list', userid)
	elif choice == 2:
		teleport_list2 = popuplib.construct('teleport_list2', 'players', '#alive', teleport_list2_select)
		teleport_list2.settitle("Select a Player:")
		teleport_list2.timeoutview = 12
		popuplib.send('teleport_list2', userid)
	elif choice == 8: admin_player(userid)
	elif choice == 9: admin_main(userid)
	popuplib.delete('teleport')

def teleport_list_select(userid, choice, popupid):
	user1 = int(userid)
	user2 = int(choice)
	if es.getplayersteamid(user2) in admins:
		es.tell(user1, '#multi', '#defaultYou cannot teleport to another Admin')
		es.tell(user2, '#multi', '#lightgreen%s#default tried to teleport to you' % es.getplayername(user1))
	else:
		es.server.cmd('es_setpos %s %s %s %s'%(user1, es.getplayerlocation(user2)[0], es.getplayerlocation(user2)[1], es.getplayerlocation(user2)[2]))
		es.setplayerprop(user1, 'CBaseEntity.m_CollisionGroup', 2)
		es.setplayerprop(user2, 'CBaseEntity.m_CollisionGroup', 2)
		es.tell(user2, '#multi', '#lightgreen%s#default teleported to you' % es.getplayername(user1))
		es.tell(user1, '#multi', '#defaultYou teleported to #lightgreen%s' % es.getplayername(user2))
	popuplib.delete('teleport_list')
	gamethread.delayed(3, unblock_player, (userid, choice))

def teleport_list2_select(userid, choice, popupid):
	user1 = int(userid)
	user2 = int(choice)
	if es.getplayersteamid(user2) in admins:
		es.tell(user1, '#multi', '#defaultAdmins cannot be teleported')
		es.tell(user2, '#multi', '#lightgreen%s#default tried to teleport you' % es.getplayername(user1))
	else:
		es.server.cmd('es_setpos %s %s %s %s'%(user2, es.getplayerlocation(user1)[0], es.getplayerlocation(user1)[1], es.getplayerlocation(user1)[2]))
		es.setplayerprop(user1, 'CBaseEntity.m_CollisionGroup', 2)
		es.setplayerprop(user2, 'CBaseEntity.m_CollisionGroup', 2)
		es.tell(int(choice), '#multi', '#defaultYou were teleported to and by #lightgreen%s' % es.getplayername(user1))
		es.tell(int(userid), '#multi', '#lightgreen%s#default was teleported to you' % es.getplayername(user2))
	popuplib.delete('teleport_list2')
	gamethread.delayed(3, unblock_player, (userid, choice))

def unblock_player(userid, choice):
	es.setplayerprop(int(choice), 'CBaseEntity.m_CollisionGroup', 0)
	es.setplayerprop(int(userid), 'CBaseEntity.m_CollisionGroup', 0)

def vote_kick_select(userid, choice, popupid):
	popuplib.delete('vote_kick')
	if es.getplayersteamid(choice) in admins:
		es.tell(userid, '#multi', '#defaultYou cannot votekick Admin')
		es.tell(choice, '#multi', '#default%s tried a votekick on you' % es.getplayername(userid))
		return
	es.msg('#multi', '#lightgreen%s#default has started a kick vote' % es.getplayername(userid))
	kick_vote = votelib.create('%s' % str(choice), vote_kick_end, vote_kick_submit)
	kick_vote.setquestion('Do you want to kick %s?' % es.getplayername(choice))
	kick_vote.addoption('Yes')
	kick_vote.addoption('No')
	if votelib.isrunning('%s' % str(choice)): es.tell(userid, '#multi', '#defaultAnother votekick is already running')
	else: kick_vote.start(60)

def vote_kick_submit(userid, votename, choice, choicename):
	es.msg('#multi', '#defaultVote kick %s - #lightgreen%s#default voted #darkgreen%s' % (es.getplayername(votename), es.getplayername(userid), choicename))

def vote_kick_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
	if cancelled:
		es.msg('#multi', '#defaultVote kick %s - #darkgreenCancelled' % es.getplayername(votename))
	else:
		if winname == 'Yes':
			es.msg('#multi', '#defaultVote kick %s - #darkgreenSuccessful#default due to majority vote' % es.getplayername(votename))
			es.server.queuecmd('kickid %s "You have been kicked by players vote"' % votename)
		else:
			es.msg('#multi', '#defaultVote kick %s - #darkgreenFailed#default due to majority vote' % es.getplayername(votename))
	votelib.delete(votename)

def vote_ban_select(userid, choice, popupid):
	popuplib.delete('vote_ban')
	if es.getplayersteamid(choice) in admins:
		es.tell(userid, '#multi', '#defaultYou cannot voteban Admin')
		es.tell(choice, '#multi', '#default%s tried a voteban on you' % es.getplayername(userid))
		return
	es.msg('#multi', '#lightgreen%s#default has started a ban vote' % es.getplayername(userid))
	ban_vote = votelib.create('%s' % str(choice), vote_ban_end, vote_ban_submit)
	ban_vote.setquestion('Do you want to ban %s?' % es.getplayername(choice))
	ban_vote.addoption('Yes')
	ban_vote.addoption('No')
	if votelib.isrunning('%s' % str(choice)): es.tell(userid, '#multi', '#defaultAnother voteban is already running')
	else: ban_vote.start(60)

def vote_ban_submit(userid, votename, choice, choicename):
	es.msg('#multi', '#defaultVote ban %s - #lightgreen%s#default voted #darkgreen%s' % (es.getplayername(votename), es.getplayername(userid), choicename))

def vote_ban_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
	if cancelled:
		es.msg('#multi', '#defaultVote ban %s - #darkgreenCancelled' % es.getplayername(votename))
	else:
		if winname == 'Yes':
			es.msg('#multi', '#defaultVote ban %s - #darkgreenSuccessful#default due to majority vote' % es.getplayername(votename))
			es.server.queuecmd('banid %i %s;kickid %s "Temporarily banned by players vote"' % (int(vote_bantime), str(votename), str(votename)))
		else:
			es.msg('#multi', '#defaultVote ban %s - #darkgreenFailed#default due to majority vote' % es.getplayername(votename))
	votelib.delete(votename)

mapcycle = es.ServerVar('eventscripts_gamedir') + '/mapcycle.txt'

def changemap_now(userid):
	change_map = popuplib.easymenu('change_map', '_popup_choice', change_map_now_select)
	change_map.settitle('Select a map:')
	list = open(mapcycle, 'r')
	for map in list:
		addchange = map.replace('\n', '')
		change_map.addoption(addchange, addchange)
	change_map.timeoutview = 12
	change_map.send(userid)
	list.close()

def change_map_now_select(userid, choice, popupid):
	popuplib.delete('change_map')
	es.msg('#multi', '#defaultAdmin changed map to #lightgreen%s#default and will start in a few seconds' % str(choice))
	gamethread.delayed(2, es.centermsg, 'The map will change in 5 SECONDS')
	gamethread.delayed(3, es.centermsg, 'The map will change in 4 SECONDS')
	gamethread.delayed(4, es.centermsg, 'The map will change in 3 SECONDS')
	gamethread.delayed(5, es.centermsg, 'The map will change in 2 SECONDS')
	gamethread.delayed(6, es.centermsg, 'The map will change in 1 SECOND')
	gamethread.delayed(7, es.server.cmd, 'changelevel %s' % choice)

def changemap_end(userid):
	change_map = popuplib.easymenu('change_map', '_popup_choice', change_map_end_select)
	change_map.settitle('Select a map:')
	list = open(mapcycle, 'r')
	for map in list:
		addchange = map.replace('\n', '')
		change_map.addoption(addchange, addchange)
	change_map.timeoutview = 12
	change_map.send(userid)
	list.close()

def change_map_end_select(userid, choice, popupid):
	popuplib.delete('change_map')
	es.msg('#multi', '#defaultAdmin changed map to #lightgreen%s#default and will start after this round' % str(choice))
	es.server.cmd('nextlevel ' + choice)

def set_nextmap(userid):
	set_nextmap = popuplib.easymenu('set_nextmap', '_popup_choice', set_nextmap_select)
	set_nextmap.settitle('Select a Map:')
	list = open(mapcycle, 'r')
	for map in list:
		addset = map.replace('\n', '')
		set_nextmap.addoption(addset, addset)
	set_nextmap.timeoutview = 12
	set_nextmap.send(userid)
	list.close()

def set_nextmap_select(userid, choice, popupid):
	popuplib.delete('set_nextmap')
	es.ServerVar('eventscripts_nextmapoverride').set(choice)
	es.msg('#multi', '#defaultAdmin set #lightgreen%s#default as next map' % str(choice))

def vote_one_map(userid):
	vote_map = popuplib.easymenu('vote_map', '_popup_choice', one_map_select)
	vote_map.settitle('Select a map:')
	list = open(mapcycle, 'r')
	for map in list:
		addvote = map.replace('\n', '')
		vote_map.addoption(addvote, addvote)
	vote_map.timeoutview = 12
	vote_map.send(userid)
	list.close()

def one_map_select(userid, choice, popupid):
	popuplib.delete('vote_map')
	vote_oneMap = votelib.create('%s' % choice, vote_oneMap_end, vote_oneMap_submit)
	vote_oneMap.setquestion('Vote %s as nextmap?' % choice)
	vote_oneMap.addoption('Yes')
	vote_oneMap.addoption('No')
	if votelib.isrunning('%s' % choice): es.tell(userid, '#multi', '#defaultAnother votemap is already running')
	else: vote_oneMap.start(60)

def vote_oneMap_submit(userid, votename, choice, choicename):
	es.msg('#multi', '#defaultVote map %s - #lightgreen%s#default voted #darkgreen%s' % (votename, es.getplayername(userid), choicename))

def vote_oneMap_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
	if cancelled:
		es.msg('#multi', '#defaultVote map %s - #darkgreenCancelled' % votename)
	else:
		if winname == 'Yes':
			es.msg('#multi', '#defaultVote map %s - #darkgreenSuccessful#default due to majority vote' % votename)
			es.msg('#multi', '#defaultMap #lightgreen%s#default will start after this round' % votename)
			es.server.cmd('nextlevel ' + votename)
		else:
			es.msg('#multi', '#defaultVote map %s - #darkgreenFailed#default due to majority vote' % votename)
	votelib.delete(votename)

def vote_all_map(userid):
	vote_allMap = votelib.create('allMap', vote_allMap_end, vote_allMap_submit)
	vote_allMap.setquestion('Vote for nextmap:')
	list = open(mapcycle, 'r')
	for map in list:
		addvote = map.replace('\n', '')
		vote_allMap.addoption(addvote)
	if votelib.isrunning('allMap'): es.tell(userid, '#multi', '#defaultAnother votemap is already running')
	else: vote_allMap.start(60)
	list.close()

def vote_allMap_submit(userid, votename, choice, choicename):
	es.msg('#multi', '#lightgreen%s#default voted for #darkgreen%s#default as nextmap' % (es.getplayername(userid), choicename))

def vote_allMap_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
	if cancelled:
		es.msg('#multi', '#defaultVote for nexmap #darkgreenCancelled')
	else:
		es.msg('#multi', '#defaultNext map will be #darkgreen%s#default due to majority vote' % winname)
		es.msg('#multi', '#defaultMap #lightgreen%s#default will start after this round' % winname)
		es.server.cmd('nextlevel ' + winname)
	votelib.delete(votename)

def server_restart():
	gamethread.delayed(1, es.centermsg, 'The game will restart in 10 SECONDS')
	gamethread.delayed(2, es.centermsg, 'The game will restart in 9 SECONDS')
	gamethread.delayed(3, es.centermsg, 'The game will restart in 8 SECONDS')
	gamethread.delayed(4, es.centermsg, 'The game will restart in 7 SECONDS')
	gamethread.delayed(5, es.centermsg, 'The game will restart in 6 SECONDS')
	gamethread.delayed(6, es.centermsg, 'The game will restart in 5 SECONDS')
	gamethread.delayed(7, es.centermsg, 'The game will restart in 4 SECONDS')
	gamethread.delayed(8, es.centermsg, 'The game will restart in 3 SECONDS')
	gamethread.delayed(9, es.centermsg, 'The game will restart in 2 SECONDS')
	gamethread.delayed(10, es.server.cmd, 'mp_restartgame 1')

def server_shutdown():
	gamethread.delayed(1, es.centermsg, 'The server will shutdown in 10 SECONDS')
	gamethread.delayed(2, es.centermsg, 'The server will shutdown in 9 SECONDS')
	gamethread.delayed(3, es.centermsg, 'The server will shutdown in 8 SECONDS')
	gamethread.delayed(4, es.centermsg, 'The server will shutdown in 7 SECONDS')
	gamethread.delayed(5, es.centermsg, 'The server will shutdown in 6 SECONDS')
	gamethread.delayed(6, es.centermsg, 'The server will shutdown in 5 SECONDS')
	gamethread.delayed(7, es.centermsg, 'The server will shutdown in 4 SECONDS')
	gamethread.delayed(8, es.centermsg, 'The server will shutdown in 3 SECONDS')
	gamethread.delayed(9, es.centermsg, 'The server will shutdown in 2 SECONDS')
	gamethread.delayed(10, es.centermsg, 'The server will shutdown in 1 SECOND')
	gamethread.delayed(11, es.server.cmd, 'quit')

def adminplugin_SayFilter(userid, text, teamonly):
	if text.strip('"').startswith('@'):
		if es.getplayersteamid(userid) in admins:
			if teamonly:
				for user in admins:
					userid = es.getuserid(user)
					if userid: es.tell(userid, '#multi', '#greenADMIN %s: #default%s' % (es.getplayername(userid), text.strip('"')[1:]))
			else: es.msg('#multi', '#greenADMIN %s: #default%s' % (es.getplayername(userid), text.strip('"')[1:]))
			return (0, None, None)
		return (userid, text, teamonly)
	elif text.strip('"').startswith('#'):
		if es.getplayersteamid(userid) in admins:
			if teamonly: es.tell(userid, '#multi', '#defaultPlease use #lightgreencommon #defaultsay chat to write center messages')
			else: es.centermsg('ADMIN: ' + text.strip('"')[1:])
			return (0, None, None)
		return (userid, text, teamonly)
	elif text.strip('"').startswith('$'):
		if es.getplayersteamid(userid) in admins:
			if teamonly: es.tell(userid, '#multi', '#defaultPlease use #lightgreencommon #defaultsay chat to write top-text messages')
			else:
				for player in es.getUseridList():
					es.toptext(player, 3, "#cyan", 'ADMIN: ' + text.strip('"')[1:])
			return (0, None, None)
		return (userid, text, teamonly)
	elif text.strip('"') == ('timeleft'):
		if es.server_var['mp_timelimit'] == 0:
			es.tell(userid, '#multi', '#defaultThere is #lightgreenno time limit#default on map')
			if es.server_var['mp_maxrounds'] != 0: es.tell(userid, '#multi', '#defaultThere is a roundlimit of #darkgreen%i#default rounds' % int(es.server_var['mp_maxrounds']))
			else:
				if es.server_var['mp_winlimit'] != 0: es.tell(userid, '#multi', '#defaultThere is a winlimit of #darkgreen%i#default rounds' % int(es.server_var['mp_winlimit']))
				else:
					if es.server_var['mp_fraglimit'] != 0: es.tell(userid, '#multi', '#defaultThere is a fraglimit of #darkgreen%i#default frags' % int(es.server_var['mp_fraglimit']))
		else:
			remaining = int(int(es.ServerVar('mp_timelimit'))*60) - int(int(time.time()) - time_left_starttime)
			timestring = _format_timeleft(remaining)
			es.tell(userid, '#multi', '#defaultTime left on map: #lightgreen%s' % str(timestring))
		return (0, None, None)
	elif text.strip('"') == ('thetime'):
		es.tell(userid, '#multi', "#defaultServer's Time: #lightgreen%s" % strftime('#green%d %b %Y #lightgreen%H:%M:%S #darkgreen%Z'))
		return (0, None, None)
	elif text.strip('"') == ('votemap'):
		if int(es.server_var['sv_votemap_enable']) == 1:
			mapvoter = popuplib.create('mapvoter')
			mapvoter.addline('Select map vote type:')
			mapvoter.addline('-------------------------')
			mapvoter.addline('->1. Specific map vote')
			mapvoter.addline('->2. All maps vote')
			mapvoter.addline(' ')
			mapvoter.addline('0. Cancel')
			mapvoter.timeoutview = 10
			mapvoter.menuselect = mapvoter_menu
			if popuplib.isqueued('mapvoter', userid): popuplib.close('mapvoter', userid)
			popuplib.send('mapvoter', userid)
		else: es.tell(userid, '#multi', '#defaultMap voting has been disabled by Admin')
		return (0, None, None)
	elif text.strip('"') == ('votekick'):
		if int(es.server_var['sv_votekick_enable']) == 1:
			vote_kick = popuplib.construct('vote_kick', 'players', '#human', vote_kick_select)
			vote_kick.settitle("Select a player:")
			vote_kick.timeoutview = 10
			popuplib.send('vote_kick', userid)
		else: es.tell(userid, '#multi', '#defaultKick voting has been disabled by Admin')
		return (0, None, None)
	elif text.strip('"') == ('voteban'):
		if int(es.server_var['sv_voteban_enable']) == 1:
			vote_ban = popuplib.construct('vote_ban', 'players', '#human', vote_ban_select)
			vote_ban.settitle("Select a player:")
			vote_ban.timeoutview = 12
			popuplib.send('vote_ban', userid)
		else: es.tell(userid, '#multi', '#defaultBan voting has been disabled by Admin')
		return (0, None, None)
	elif text.strip('"') == ('adminlist'):
		admin_list = popuplib.easymenu('admin_list', '_popup_choice', admin_list_select)
		admin_list.settitle('Server Admins:')
		for admin in admins:
			admin_name = es.getplayername(es.getuserid(admin))
			admin_list.addoption(admin_name, admin_name)
		admin_list.timeoutview = 10
		admin_list.send(userid)
		return (0, None, None)
	return (userid, text, teamonly)

def admin_list_select(userid, choice, popupid):
	popuplib.delete('admin_list')

def _format_timeleft(ticker):
	minutes = int(int(ticker) / 60)
	seconds = int(int(ticker) - int(minutes * 60))
	if minutes < 10:
		show_minutes = '0%i' % minutes
	else:
		show_minutes = minutes
	if seconds < 10:
		show_seconds = '0%i' % seconds
	else:
		show_seconds = seconds
	timestring = str(show_minutes) + ':' + str(show_seconds)
	return timestring

def mapvoter_menu(userid, choice, popupid):
	if choice == 1: vote_one_map(userid)
	elif choice == 2: vote_all_map(userid)
	popuplib.delete('mapvoter')

adverts = es.getAddonPath('adminplugin') + '/adverts.txt'

def show_adverts():
	if int(es.server_var['sv_adverts_enable']) == 0:
		gamethread.delayedname(30, "adverts", show_adverts)
		return
	advert_list = []
	adverts_file = open(adverts, 'r')
	for line in adverts_file:
		advert_list.append(line)
	for client in playerlib.getPlayerList('#human'):
		clientid = int(client)
		es.tell(clientid, '#multi', '#green[Info]#default ' + random.choice(advert_list))
	adverts_file.close()
	gamethread.delayedname(int(es.server_var['sv_adverts_time']), "adverts", show_adverts)

def unload():
	es.unregclientcmd('admin_menu')
	es.addons.unregisterSayFilter(adminplugin_SayFilter)
	gamethread.cancelDelayed("adverts")